=== removed file 'doc/code.rst'
--- doc/code.rst	2011-12-22 06:11:18 +0000
+++ doc/code.rst	1970-01-01 00:00:00 +0000
@@ -1,12 +0,0 @@
-
-Code Documentation
-******************
-
-.. automodule:: lava_dispatcher
-    :members:
-
-.. automodule:: lava_dispatcher.client.base
-    :members:
-
-.. automodule:: lava_dispatcher.client.master
-    :members:

=== modified file 'doc/configuration.rst'
--- doc/configuration.rst	2012-04-26 03:32:35 +0000
+++ doc/configuration.rst	1970-01-01 00:00:00 +0000
@@ -1,18 +0,0 @@
-.. _configuration:
-
-Configuration
-=============
-
-Guideline
-^^^^^^^^^
-
-Please refer to README in lava-dispatcher source code::
-
-    lava-dispatcher/lava_dispatcher/default-config/lava-dispatcher/README
-
-Or browse on the `web page <http://bazaar.launchpad.net/~linaro-validation/lava-dispatcher/trunk/view/head:/lava_dispatcher/default-config/lava-dispatcher/README>`_
-
-Don't forget to setup LAVA_SERVER_IP, and LAVA_PROXY if there is one proxy,
-which will prompt the performance explicitly.
-
-You can set up a squid service, refer to :ref:`proxy`

=== target is u'../lava_dispatcher/default-config/lava-dispatcher/README'
=== modified file 'doc/index.rst'
--- doc/index.rst	2012-10-10 19:29:04 +0000
+++ doc/index.rst	2012-10-11 02:51:21 +0000
@@ -8,24 +8,10 @@
 boards in validation farm, and publish the test result back to dashboard. It is
 scheduled by validation scheduler, and it could also run as standalone.
 
-.. seealso:: To learn more about LAVA see https://launchpad.net/lava
-
-
-Features
-========
-
-* Ability to accept, parse and run a job which consists of different actions
-  and test cases, then upload test result to LAVA Dashboard on an ARM target
-  system.
-* Support ARM target boards including Beagle, Panda, i.MX51 EVK, i.MX53
-  QuickStart, Snowball, Origen, Versatile Express, Fast Models, and QEMU.
-* Support Android system on Panda, i.MX53 QuickStart board, Snowball, Origen,
-  Versatile Express, and Fast Models.
-* Support for local user-defined configuration data for boards, device types.
-* Extensible device types and boards configuration editing, can add new device
-  and new board.
-* Make use of the output of LAVA test, which is Linaro Dashboard Bundle format,
-  upload test results to the LAVA Dashboard for result archiving and analysis.
+You can see an up-to-date list of supported target devices by looking at the
+`device types`_ in Launchpad.
+
+.. _device types: http://bazaar.launchpad.net/~linaro-validation/lava-dispatcher/trunk/files/head:/lava_dispatcher/default-config/lava-dispatcher/device-types
 
 Installation
 ============
@@ -37,12 +23,30 @@
 .. _main project page: http://lava.readthedocs.org/en/latest/
 .. _stand-alone development and testing: standalonesetup.html
 
+Indices and tables
+==================
+
+.. toctree::
+   :maxdepth: 2
+
+   standalonesetup.rst
+   configuration.rst
+   jobfile.rst
+   usage.rst
+   proxy.rst
+
+* :ref:`search`
+
 Source code, bugs and patches
 =============================
 
 The project is maintained on Launchpad at
 http://launchpad.net/lava-dispatcher/.
 
+We maintain an online log of `release notes`_
+
+.. _release notes: changes.html
+
 You can get the source code with bazaar using ``bzr branch
 lp:lava-dispatcher``.  Patches can be submitted using Launchpad merge proposals
 (for introduction to this and topic see
@@ -53,22 +57,4 @@
 Most of the team is usually available in ``#linaro`` on ``irc.freenode.net``.
 Feel free to drop by to chat and ask questions.
 
-Indices and tables
-==================
-
-.. toctree::
-   :maxdepth: 2
-
-   standalonesetup.rst
-   configuration.rst
-   proxy.rst
-   jobfile.rst
-   usage.rst
-   changes.rst
-   code.rst
-   todo.rst
-
-* :ref:`genindex`
-* :ref:`modindex`
-* :ref:`search`
 

=== removed file 'doc/todo.rst'
--- doc/todo.rst	2011-10-09 09:46:11 +0000
+++ doc/todo.rst	1970-01-01 00:00:00 +0000
@@ -1,4 +0,0 @@
-List of items that need work
-============================
-
-.. todolist::

=== modified file 'doc/usage.rst'
--- doc/usage.rst	2011-10-09 09:46:11 +0000
+++ doc/usage.rst	2012-10-11 03:22:08 +0000
@@ -19,46 +19,15 @@
 job file that are to be executed and then executes them manually (by manually
 running LAVA Dispatcher, the actual execution process are non-interactive).
 
-Typically this mode is based on the following sequence of commands:
-
-#. Install lava-dispatcher (from PPA or source) along with the required dependencies on LAVA Server.
-#. Configure local or remote development boards and device types.
-#. Add or edit job files which are to be executed.
-#. Execute dispatcher manually: $ sudo lava-dispatch ./lava-ltp-job.json
-
-At last dispatcher will publish the test results to LAVA Dashboard.
+Follow the `Quick Developer Setup`_ instructions to get started.
+
+.. _Quick Developer Setup: standalonesetup.html
 
 Usage with the LAVA Scheduler
 ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
 
 The scheduler is useful for automating LAVA Dispatcher environment setup, describing test scenarios (the list of tests to invoke) and finally storing the results in the LAVA dashboard.
 
-Typically this mode is based on the following sequence of commands:
-
-#. Install lava-dispatcher (from PPA or source) along with the required dependencies on LAVA Server.
-#. Configure local or remote development boards and device types.
-#. Add or edit job files which are to be executed.
-#. Configure LAVA Scheduler to execute job files.
-
-Debug
-^^^^^
-    
-Debug 
-
-.. todo::
-
-    Describe how to collect enough information to debug dispatcher when the job execution failed.
-
-Check test result on LAVA Dashboard
-===================================
-
-.. todo::
-
-    Describe how to view test results on dashboard.
-
-Debug with serial log
-==============================
-
-.. todo::
-
-    Describe the information including logging information/warning and exception information.
+This scenario can be configured by following our `deployment instructions`_
+
+.. _deployment instructions: http://lava.readthedocs.org/en/latest/

=== modified file 'lava_dispatcher/default-config/lava-dispatcher/README'
--- lava_dispatcher/default-config/lava-dispatcher/README	2012-04-10 10:56:09 +0000
+++ lava_dispatcher/default-config/lava-dispatcher/README	2012-10-11 02:51:21 +0000
@@ -10,6 +10,9 @@
 
  * ~/.config/lava-dispatcher for user settings.
 
+ * /srv/lava/<instance>/etc/lava-dispatcher for deployments done using
+   lava-deployment-tool
+
 Each config directory can contain two files and two directories:
 
  * lava-dispatcher.conf